/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010, 2011 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

 int myclock() 
{
#if defined (__MINGW) || defined(__MINGW32__)
    return clock()/80;
#else
    return clock()/1000;
#endif    
}

void text_out(char *txt)
{
    printf("%d:: %s\n",myclock(),txt);fflush(stdout);
}

void scan_sensor(char *txt, int *temp) 
{
    text_out(txt);
    scanf("%d",temp);
}

void assertion(char *aname, int val) 
{
    printf("!PROG: assert %s:%d:%d:!\n",aname, val, myclock());fflush(stdout);
}

void assertion1(char *aname, int val) 
{
    printf("!PROG: assert %s:%d:%d:%d:%d:!\n",aname, val, 1,2,myclock());fflush(stdout);
}
