/* 
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2012-2013  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import java.io.*;
import java.util.*;

public class Main {

    public static BufferedReader inp;
    public static BufferedWriter out;

    public static void print(String s) {
    System.out.println(s);
    }

    public static String pipe(String msg) {
    String ret;

    try {
        out.write( msg + "\n" );
        out.flush();
        ret = inp.readLine();
        return ret;
    }
    catch (Exception err) {

    }
    return "really?";
    }



    public static void main(String[] args) {

    String s;
        //   String cmd = "c:\\Users\\cau\\Desktop\\tempura\\tempura-2.18\\Examples\\csharp\\test.exe"; 
    String cmd = "/home/acau/ctempura/tempura/Examples/csharp/test.exe";
    

    try {

            //print(cmd);
            //print(System.getProperty("user.dir"));
        Process p = Runtime.getRuntime().exec(cmd);

        inp = new BufferedReader( new InputStreamReader(p.getInputStream()) );
        out = new BufferedWriter( new OutputStreamWriter(p.getOutputStream()) );

        print( pipe("test 1") );
        print( "what now" );
        print( pipe("test 2") );
        print( "what now 1" ) ;
        print (pipe("test 3") );
        print( "what now 2" );
        print(pipe("end") );
        print( "what now 3" );
        
        
        inp.close();
        out.close();
    }

    catch (Exception err) {
        err.printStackTrace();
    }
    }
}
