/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2013  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * example of add elements of a list
 */


/* adding sum in state 0 */
/* run */ define test_1() = 
{ exists A, Sum : 
  {
      define add(A) = 
      {
          if |A|=0 then 0
          else A[0] + add(A[1..|A|])        
      }
      and
      A=[1,2,3,4,5,6] and output Sum and
      empty and Sum=add(A)
  }
}
.

/* adding per state */
/* run */ define test_2() = 
{ exists A, I, Sum : 
  {
      list(A,6) and stable(struct(A)) and
      A=[1,2,3,4,5,6] and stable(A) and
      I=0 and I gets I+1 and
      always output I and len(|A|) and fin output Sum and
          /* always (if I=|A| then output Sum) and*/
      Sum=0 and Sum gets Sum + A[I]
  }
}
.
