/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "parser.y"

/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2013  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: parser.y 150 2013-04-11 14:14:53Z acau $
 */    
#include "system.h"
void yyerror(char const *);
/*#define YYPARSE_PARAM scanner
  #define YYLEX_PARAM   scanner*/


/* Line 268 of yacc.c  */
#line 101 "parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     MINTOKEN = 258,
     FORTIMES = 259,
     FORIN = 260,
     MAKELIST = 261,
     SUB = 262,
     SUBLIST = 263,
     BOOL = 264,
     LOC = 265,
     STATE = 266,
     STATIC = 267,
     LIST = 268,
     CALL = 269,
     iCALL = 270,
     iEXISTS = 271,
     iPROCESS = 272,
     iPREFIX = 273,
     iFOR = 274,
     iFORTIMES = 275,
     iFORIN = 276,
     iPROJ = 277,
     iSEMI = 278,
     iAND = 279,
     ENV = 280,
     BND = 281,
     MEMBLOCK = 282,
     iIF = 283,
     iSYSTEM = 284,
     iLEN = 285,
     iOR = 286,
     iUNDEFINED = 287,
     RUN = 288,
     WHILE = 289,
     FOR = 290,
     IN = 291,
     TIMES = 292,
     REPEAT = 293,
     EXISTS = 294,
     FORALL = 295,
     TO = 296,
     SIZE = 297,
     TRUE = 298,
     FALSE = 299,
     LAMBDA = 300,
     SKIP = 301,
     EMPTY = 302,
     MORE = 303,
     RANLEN = 304,
     INFINITE = 305,
     END = 306,
     NAME = 307,
     STRING = 308,
     FLOAT = 309,
     INT = 310,
     PROJ = 311,
     FIXLIST = 312,
     VARLIST = 313,
     NPREV = 314,
     SHOWMEM = 315,
     EXIT = 316,
     SHOWTRACE = 317,
     SHOWSTATE = 318,
     ABORT = 319,
     BREAK = 320,
     RETURN = 321,
     CONTINUE = 322,
     LEAP = 323,
     STEP = 324,
     PASSLIMIT = 325,
     VERBOSITY = 326,
     PRINTLEVEL = 327,
     DEBUGLEVEL = 328,
     STATEPRINT = 329,
     REDUNDANCY = 330,
     CALLBYNAME = 331,
     ASSIGNAHEAD = 332,
     BREAKISABORT = 333,
     HOPCHOP = 334,
     PATH = 335,
     HELPDIR = 336,
     INFILE = 337,
     OUTFILE = 338,
     TIMESTEP = 339,
     RANDSEED = 340,
     RRANDSEED = 341,
     SRANDSEED = 342,
     SRRANDSEED = 343,
     MAXRANDLEN = 344,
     PRECISION = 345,
     RANDOM = 346,
     RRANDOM = 347,
     SRANDOM = 348,
     SRRANDOM = 349,
     NIL = 350,
     LBRACE = 351,
     PROCESS = 352,
     LPAREN = 353,
     LBRACK = 354,
     RBRACE = 355,
     RPAREN = 356,
     RBRACK = 357,
     BAR = 358,
     SEMI = 359,
     IMPLIES = 360,
     OR = 361,
     WHERE = 362,
     AND = 363,
     IF = 364,
     THEN = 365,
     IFX = 366,
     ELSE = 367,
     ATANTWO = 368,
     FORMAT = 369,
     SET = 370,
     DEFINE = 371,
     HISTORY = 372,
     UNTIL = 373,
     DO = 374,
     HELP = 375,
     DEFAULTS = 376,
     UASSN = 377,
     ASSN = 378,
     IS = 379,
     GETS = 380,
     KEEP = 381,
     NEQ = 382,
     GT = 383,
     GE = 384,
     EQ = 385,
     LE = 386,
     LT = 387,
     THE = 388,
     LEN = 389,
     MINUS = 390,
     PLUS = 391,
     MOD = 392,
     DIV = 393,
     MULT = 394,
     POWER = 395,
     MEM = 396,
     STB = 397,
     INIT = 398,
     FIN = 399,
     HALT = 400,
     SOMETIME = 401,
     ALWAYS = 402,
     PREFIX = 403,
     CHOPSTAR = 404,
     PEEK = 405,
     OUTPUT = 406,
     WINPUT = 407,
     INPUT = 408,
     SYSTEM = 409,
     LOAD = 410,
     STRUCT = 411,
     ASCII = 412,
     TYPE = 413,
     PREV = 414,
     WNEXT = 415,
     NEXT = 416,
     NOT = 417,
     LOGTEN = 418,
     LOG = 419,
     EXPO = 420,
     ITOF = 421,
     SQRT = 422,
     FLOOR = 423,
     CEIL = 424,
     UPLUS = 425,
     UMINUS = 426,
     FABS = 427,
     TANH = 428,
     COSH = 429,
     SINH = 430,
     ATAN = 431,
     ACOS = 432,
     ASIN = 433,
     TAN = 434,
     COS = 435,
     SIN = 436,
     DEREF = 437,
     REFER = 438,
     COMMA = 439,
     MAXTOKEN = 440,
     MQS = 441,
     IDN = 442,
     MDF = 443,
     EIF = 444,
     H1 = 445,
     STL = 446,
     IPTL = 447
   };
#endif
/* Tokens.  */
#define MINTOKEN 258
#define FORTIMES 259
#define FORIN 260
#define MAKELIST 261
#define SUB 262
#define SUBLIST 263
#define BOOL 264
#define LOC 265
#define STATE 266
#define STATIC 267
#define LIST 268
#define CALL 269
#define iCALL 270
#define iEXISTS 271
#define iPROCESS 272
#define iPREFIX 273
#define iFOR 274
#define iFORTIMES 275
#define iFORIN 276
#define iPROJ 277
#define iSEMI 278
#define iAND 279
#define ENV 280
#define BND 281
#define MEMBLOCK 282
#define iIF 283
#define iSYSTEM 284
#define iLEN 285
#define iOR 286
#define iUNDEFINED 287
#define RUN 288
#define WHILE 289
#define FOR 290
#define IN 291
#define TIMES 292
#define REPEAT 293
#define EXISTS 294
#define FORALL 295
#define TO 296
#define SIZE 297
#define TRUE 298
#define FALSE 299
#define LAMBDA 300
#define SKIP 301
#define EMPTY 302
#define MORE 303
#define RANLEN 304
#define INFINITE 305
#define END 306
#define NAME 307
#define STRING 308
#define FLOAT 309
#define INT 310
#define PROJ 311
#define FIXLIST 312
#define VARLIST 313
#define NPREV 314
#define SHOWMEM 315
#define EXIT 316
#define SHOWTRACE 317
#define SHOWSTATE 318
#define ABORT 319
#define BREAK 320
#define RETURN 321
#define CONTINUE 322
#define LEAP 323
#define STEP 324
#define PASSLIMIT 325
#define VERBOSITY 326
#define PRINTLEVEL 327
#define DEBUGLEVEL 328
#define STATEPRINT 329
#define REDUNDANCY 330
#define CALLBYNAME 331
#define ASSIGNAHEAD 332
#define BREAKISABORT 333
#define HOPCHOP 334
#define PATH 335
#define HELPDIR 336
#define INFILE 337
#define OUTFILE 338
#define TIMESTEP 339
#define RANDSEED 340
#define RRANDSEED 341
#define SRANDSEED 342
#define SRRANDSEED 343
#define MAXRANDLEN 344
#define PRECISION 345
#define RANDOM 346
#define RRANDOM 347
#define SRANDOM 348
#define SRRANDOM 349
#define NIL 350
#define LBRACE 351
#define PROCESS 352
#define LPAREN 353
#define LBRACK 354
#define RBRACE 355
#define RPAREN 356
#define RBRACK 357
#define BAR 358
#define SEMI 359
#define IMPLIES 360
#define OR 361
#define WHERE 362
#define AND 363
#define IF 364
#define THEN 365
#define IFX 366
#define ELSE 367
#define ATANTWO 368
#define FORMAT 369
#define SET 370
#define DEFINE 371
#define HISTORY 372
#define UNTIL 373
#define DO 374
#define HELP 375
#define DEFAULTS 376
#define UASSN 377
#define ASSN 378
#define IS 379
#define GETS 380
#define KEEP 381
#define NEQ 382
#define GT 383
#define GE 384
#define EQ 385
#define LE 386
#define LT 387
#define THE 388
#define LEN 389
#define MINUS 390
#define PLUS 391
#define MOD 392
#define DIV 393
#define MULT 394
#define POWER 395
#define MEM 396
#define STB 397
#define INIT 398
#define FIN 399
#define HALT 400
#define SOMETIME 401
#define ALWAYS 402
#define PREFIX 403
#define CHOPSTAR 404
#define PEEK 405
#define OUTPUT 406
#define WINPUT 407
#define INPUT 408
#define SYSTEM 409
#define LOAD 410
#define STRUCT 411
#define ASCII 412
#define TYPE 413
#define PREV 414
#define WNEXT 415
#define NEXT 416
#define NOT 417
#define LOGTEN 418
#define LOG 419
#define EXPO 420
#define ITOF 421
#define SQRT 422
#define FLOOR 423
#define CEIL 424
#define UPLUS 425
#define UMINUS 426
#define FABS 427
#define TANH 428
#define COSH 429
#define SINH 430
#define ATAN 431
#define ACOS 432
#define ASIN 433
#define TAN 434
#define COS 435
#define SIN 436
#define DEREF 437
#define REFER 438
#define COMMA 439
#define MAXTOKEN 440
#define MQS 441
#define IDN 442
#define MDF 443
#define EIF 444
#define H1 445
#define STL 446
#define IPTL 447




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 31 "parser.y"

    int tokentype;
    NODEPTR nodetype;



/* Line 293 of yacc.c  */
#line 528 "parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 553 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  204
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2847

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  193
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  15
/* YYNRULES -- Number of rules.  */
#define YYNRULES  171
/* YYNRULES -- Number of states.  */
#define YYNSTATES  350

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   447

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    12,    16,    20,    25,    32,
      36,    41,    48,    54,    59,    62,    67,    72,    79,    84,
      91,    96,    99,   102,   107,   110,   113,   116,   119,   124,
     132,   135,   138,   143,   146,   149,   154,   161,   166,   173,
     177,   181,   185,   188,   192,   196,   200,   204,   208,   212,
     215,   218,   222,   225,   228,   231,   234,   237,   240,   243,
     246,   249,   252,   255,   258,   261,   268,   272,   276,   280,
     284,   288,   292,   295,   298,   301,   304,   308,   312,   316,
     320,   324,   328,   331,   334,   337,   340,   343,   346,   349,
     352,   355,   358,   361,   364,   367,   370,   373,   376,   379,
     386,   393,   400,   404,   406,   408,   410,   412,   414,   418,
     422,   427,   434,   436,   441,   443,   445,   447,   449,   451,
     453,   455,   457,   459,   461,   463,   465,   467,   469,   471,
     473,   475,   477,   479,   481,   483,   485,   487,   489,   491,
     493,   495,   497,   499,   501,   503,   505,   507,   509,   511,
     513,   515,   517,   519,   521,   523,   525,   527,   529,   531,
     533,   535,   536,   538,   540,   544,   545,   547,   551,   553,
     557,   561
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     194,     0,    -1,   195,    -1,   194,   196,    51,    -1,   196,
      51,    -1,    96,   196,   100,    -1,    98,   196,   101,    -1,
     109,   196,   110,   196,    -1,   109,   196,   110,   196,   112,
     196,    -1,   196,   105,   196,    -1,    34,   196,   119,   196,
      -1,    35,    52,    36,   196,   119,   196,    -1,    35,   196,
      37,   119,   196,    -1,    35,   207,   119,   196,    -1,   149,
     196,    -1,    38,   196,   118,   196,    -1,    39,   203,   119,
     196,    -1,    39,   203,   117,   196,   119,   196,    -1,    39,
     207,   119,   196,    -1,    39,   207,   117,   196,   119,   196,
      -1,    40,   207,   119,   196,    -1,    33,   196,    -1,   155,
     196,    -1,   114,    98,   205,   101,    -1,   151,   196,    -1,
     152,   196,    -1,   153,   196,    -1,   150,   196,    -1,   116,
      52,   130,   196,    -1,   116,    52,    98,   203,   101,   130,
     196,    -1,   158,   196,    -1,   157,   196,    -1,   115,   202,
     130,   196,    -1,   120,   196,    -1,   154,   196,    -1,    52,
      98,   205,   101,    -1,    45,    98,   203,   101,   119,   196,
      -1,   133,   196,   119,   196,    -1,    60,    98,   196,   184,
     196,   101,    -1,   196,   106,   196,    -1,   196,   108,   196,
      -1,   196,   107,   196,    -1,   162,   196,    -1,   196,   104,
     196,    -1,   196,   125,   196,    -1,   196,   124,   196,    -1,
     196,   123,   196,    -1,   196,   122,   196,    -1,   196,   121,
     196,    -1,    97,   196,    -1,   148,   196,    -1,   196,    56,
     196,    -1,   147,   196,    -1,   146,   196,    -1,   145,   196,
      -1,   134,   196,    -1,   141,   196,    -1,   144,   196,    -1,
     143,   196,    -1,   126,   196,    -1,   142,   196,    -1,   156,
     196,    -1,   161,   196,    -1,   160,   196,    -1,   159,   196,
      -1,    59,    98,   196,   184,   196,   101,    -1,   196,   132,
     196,    -1,   196,   131,   196,    -1,   196,   130,   196,    -1,
     196,   129,   196,    -1,   196,   128,   196,    -1,   196,   127,
     196,    -1,   183,   196,    -1,   182,   196,    -1,   136,   196,
      -1,   135,   196,    -1,   196,   136,   196,    -1,   196,   135,
     196,    -1,   196,   139,   196,    -1,   196,   138,   196,    -1,
     196,   137,   196,    -1,   196,   140,   196,    -1,   169,   196,
      -1,   168,   196,    -1,   167,   196,    -1,   166,   196,    -1,
     165,   196,    -1,   164,   196,    -1,   163,   196,    -1,   181,
     196,    -1,   180,   196,    -1,   179,   196,    -1,   178,   196,
      -1,   177,   196,    -1,   176,   196,    -1,   175,   196,    -1,
     174,   196,    -1,   173,   196,    -1,   172,   196,    -1,   113,
      98,   196,   184,   196,   101,    -1,    57,    98,   196,   184,
     196,   101,    -1,    58,    98,   196,   184,   196,   101,    -1,
     103,   196,   103,    -1,   197,    -1,   201,    -1,     1,    -1,
     198,    -1,   199,    -1,    99,   205,   102,    -1,   200,    99,
     102,    -1,   200,    99,   196,   102,    -1,   200,    99,   196,
      41,   196,   102,    -1,    52,    -1,    52,    98,   205,   101,
      -1,   197,    -1,    52,    -1,    43,    -1,    44,    -1,    95,
      -1,    53,    -1,    47,    -1,    46,    -1,    48,    -1,    49,
      -1,    50,    -1,    91,    -1,    92,    -1,    93,    -1,    94,
      -1,    68,    -1,    69,    -1,    65,    -1,    67,    -1,    66,
      -1,    64,    -1,    62,    -1,    63,    -1,    61,    -1,    55,
      -1,    54,    -1,    70,    -1,    71,    -1,    72,    -1,    73,
      -1,    74,    -1,    75,    -1,    76,    -1,    77,    -1,    78,
      -1,    79,    -1,    80,    -1,    81,    -1,    82,    -1,    83,
      -1,    84,    -1,    85,    -1,    86,    -1,    87,    -1,    88,
      -1,    89,    -1,    90,    -1,    -1,   204,    -1,    52,    -1,
      52,   184,   204,    -1,    -1,   206,    -1,    98,   205,   101,
      -1,   196,    -1,   196,   184,   206,    -1,    52,   132,   196,
      -1,    98,    52,   132,   196,   101,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   117,   117,   120,   121,   127,   128,   131,   132,   133,
     136,   137,   138,   139,   140,   141,   144,   145,   149,   150,
     153,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   176,
     177,   178,   179,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   207,   208,   209,   210,
     211,   212,   215,   216,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     249,   250,   251,   254,   255,   256,   260,   261,   265,   269,
     270,   271,   275,   276,   277,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   336,   337,   341,   342,   346,   347,   348,   352,   353,
     357,   358
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "MINTOKEN", "FORTIMES", "FORIN",
  "MAKELIST", "SUB", "SUBLIST", "BOOL", "LOC", "STATE", "STATIC", "LIST",
  "CALL", "iCALL", "iEXISTS", "iPROCESS", "iPREFIX", "iFOR", "iFORTIMES",
  "iFORIN", "iPROJ", "iSEMI", "iAND", "ENV", "BND", "MEMBLOCK", "iIF",
  "iSYSTEM", "iLEN", "iOR", "iUNDEFINED", "RUN", "WHILE", "FOR", "IN",
  "TIMES", "REPEAT", "EXISTS", "FORALL", "TO", "SIZE", "TRUE", "FALSE",
  "LAMBDA", "SKIP", "EMPTY", "MORE", "RANLEN", "INFINITE", "END", "NAME",
  "STRING", "FLOAT", "INT", "PROJ", "FIXLIST", "VARLIST", "NPREV",
  "SHOWMEM", "EXIT", "SHOWTRACE", "SHOWSTATE", "ABORT", "BREAK", "RETURN",
  "CONTINUE", "LEAP", "STEP", "PASSLIMIT", "VERBOSITY", "PRINTLEVEL",
  "DEBUGLEVEL", "STATEPRINT", "REDUNDANCY", "CALLBYNAME", "ASSIGNAHEAD",
  "BREAKISABORT", "HOPCHOP", "PATH", "HELPDIR", "INFILE", "OUTFILE",
  "TIMESTEP", "RANDSEED", "RRANDSEED", "SRANDSEED", "SRRANDSEED",
  "MAXRANDLEN", "PRECISION", "RANDOM", "RRANDOM", "SRANDOM", "SRRANDOM",
  "NIL", "LBRACE", "PROCESS", "LPAREN", "LBRACK", "RBRACE", "RPAREN",
  "RBRACK", "BAR", "SEMI", "IMPLIES", "OR", "WHERE", "AND", "IF", "THEN",
  "IFX", "ELSE", "ATANTWO", "FORMAT", "SET", "DEFINE", "HISTORY", "UNTIL",
  "DO", "HELP", "DEFAULTS", "UASSN", "ASSN", "IS", "GETS", "KEEP", "NEQ",
  "GT", "GE", "EQ", "LE", "LT", "THE", "LEN", "MINUS", "PLUS", "MOD",
  "DIV", "MULT", "POWER", "MEM", "STB", "INIT", "FIN", "HALT", "SOMETIME",
  "ALWAYS", "PREFIX", "CHOPSTAR", "PEEK", "OUTPUT", "WINPUT", "INPUT",
  "SYSTEM", "LOAD", "STRUCT", "ASCII", "TYPE", "PREV", "WNEXT", "NEXT",
  "NOT", "LOGTEN", "LOG", "EXPO", "ITOF", "SQRT", "FLOOR", "CEIL", "UPLUS",
  "UMINUS", "FABS", "TANH", "COSH", "SINH", "ATAN", "ACOS", "ASIN", "TAN",
  "COS", "SIN", "DEREF", "REFER", "COMMA", "MAXTOKEN", "MQS", "IDN", "MDF",
  "EIF", "H1", "STL", "IPTL", "$accept", "program",
  "non_empty_expression_end_list", "expression", "list_expression", "list",
  "sublist", "list_expr", "atom", "set_expression", "name_list",
  "non_empty_name_list", "expression_list", "non_empty_expression_list",
  "for_range", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   193,   194,   195,   195,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   197,   197,   198,   199,
     199,   199,   200,   200,   200,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   203,   203,   204,   204,   205,   205,   205,   206,   206,
     207,   207
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     2,     3,     3,     4,     6,     3,
       4,     6,     5,     4,     2,     4,     4,     6,     4,     6,
       4,     2,     2,     4,     2,     2,     2,     2,     4,     7,
       2,     2,     4,     2,     2,     4,     6,     4,     6,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     6,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     6,
       6,     6,     3,     1,     1,     1,     1,     1,     3,     3,
       4,     6,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     3,     0,     1,     3,     1,     3,
       3,     5
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   105,     0,     0,     0,     0,   161,     0,   116,   117,
       0,   121,   120,   122,   123,   124,   115,   119,   139,   138,
       0,     0,     0,     0,   137,   135,   136,   134,   131,   133,
     132,   129,   130,   125,   126,   127,   128,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     0,   103,   106,
     107,     0,   104,    21,     0,   115,     0,     0,     0,     0,
     163,     0,     0,   162,     0,     0,     0,   161,     0,     0,
       0,     0,     0,     0,    49,     0,     0,   168,     0,   166,
       0,     0,     0,     0,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,     0,     0,    33,    59,     0,
      55,    75,    74,    56,    60,    58,    57,    54,    53,    52,
      50,    14,    27,    24,    25,    26,    34,    22,    61,    31,
      30,    64,    63,    62,    42,    88,    87,    86,    85,    84,
      83,    82,    98,    97,    96,    95,    94,    93,    92,    91,
      90,    89,    73,    72,     1,     0,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   115,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   163,     0,     0,     0,     0,
       0,     0,     5,     6,     0,     0,     0,   108,   102,     0,
       0,     0,     0,   161,     0,     0,     3,    51,    43,     9,
      39,    41,    40,    48,    47,    46,    45,    44,    71,    70,
      69,    68,    67,    66,    77,    76,    80,    79,    78,    81,
     109,     0,    10,     0,   170,     0,     0,    13,    15,   164,
       0,    16,     0,    18,    20,     0,    35,     0,     0,     0,
       0,   167,   169,     7,     0,    23,    32,     0,    28,    37,
       0,   110,     0,     0,    12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    11,   171,    17,    19,
      36,   100,   101,    65,    38,     8,    99,     0,   111,    29
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    95,    96,   127,    98,    99,   100,   101,   102,   155,
     112,   113,   128,   129,   108
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -129
static const yytype_int16 yypact[] =
{
     981,  -129,   981,   981,  1150,   981,    47,    48,  -129,  -129,
     -92,  -129,  -129,  -129,  -129,  -129,   -72,  -129,  -129,  -129,
     -79,   -62,   -54,   -51,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,   981,   981,
     981,   474,   981,   981,     5,     7,  2757,    56,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   305,  -129,  1777,    24,  -129,
    -129,    25,  -129,  2543,  1854,    -2,  1319,  1679,     6,  1891,
     -86,    75,   -82,  -129,   -15,    -4,    10,    79,   643,   981,
     981,   981,   981,  1932,  1641,  1977,   643,   145,    31,  -129,
    2017,  2054,   981,   643,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,     4,   -85,  -107,   162,  2094,
     -25,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  1814,  -129,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   981,   981,   981,
     812,   981,   981,   981,   -91,    16,   981,   981,    79,     8,
     981,   981,   981,   981,   981,   -48,    36,    37,  1400,  1458,
    1495,  1553,  -129,  -129,    51,    38,   981,  -129,  -129,   981,
    1590,    40,   981,    79,   981,   981,  -129,  1641,  2579,  2614,
    2640,  2665,  -107,   254,   254,   254,   254,   254,   362,   362,
     362,   362,   362,   362,  -128,  -128,     2,     2,     2,  -129,
    -129,  1719,  -107,  2131,  2543,   981,   981,  -107,  -107,  -129,
    2171,  -107,  2208,  -107,  -107,    29,    44,   981,   981,   981,
     981,  -129,  -129,  2686,   981,  -129,   362,    43,   362,  -107,
     981,  -129,   981,  2248,  -107,   981,   981,   981,  2294,  2334,
    2380,  2420,   981,  2466,    19,  2505,  -107,  -129,  -107,  -107,
    -107,  -129,  -129,  -129,  -129,  -107,  -129,   981,  -129,   362
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -129,  -129,  -129,     0,  -129,  -129,  -129,  -129,  -129,  -129,
    -116,   -88,   -17,  -105,   111
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -166
static const yytype_int16 yytable[] =
{
      97,   246,   103,   104,   107,   109,   117,   118,  -112,   226,
     227,   228,   229,   263,   213,   214,   215,   216,   217,   119,
     218,   219,   220,   221,   222,   223,   118,  -112,   224,   225,
     226,   227,   228,   229,   232,   240,   120,   241,   123,   124,
     125,   295,   130,   131,   121,   264,   233,   122,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   205,   118,  -112,   238,   110,
     115,   247,   242,   132,   243,   133,   125,   207,   156,   255,
     224,   225,   226,   227,   228,   229,   261,   114,   116,   248,
     249,   250,   251,  -114,   230,   236,   254,   239,   233,   244,
     233,   245,   260,   257,   262,   296,   238,   305,   306,   311,
     295,   315,   229,  -113,   334,   111,   111,   317,   327,   347,
     299,   312,   253,     0,     0,   208,   209,   210,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,   223,     0,     0,   224,   225,   226,   227,
     228,   229,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     0,     0,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     291,   292,   293,   294,     0,   256,   297,   298,     0,     0,
     300,   301,   302,   303,   304,     0,     0,     0,     0,   208,
     209,   210,   211,   212,     0,     0,     0,     0,     0,   313,
       0,     0,   316,     0,   318,   319,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,   223,     0,     0,
     224,   225,   226,   227,   228,   229,     0,     0,     0,   218,
     219,   220,   221,   222,   223,   323,   324,   224,   225,   226,
     227,   228,   229,     0,     0,   204,     1,   328,   329,   330,
     331,     0,     0,     0,   333,     0,     0,     0,     0,     0,
     335,     0,   336,     0,     0,   338,   339,   340,     0,   256,
       0,     0,   345,     0,     0,     0,     0,     0,     2,     3,
       4,     0,     0,     5,     6,     7,     0,   349,     8,     9,
      10,    11,    12,    13,    14,    15,     0,    16,    17,    18,
      19,     0,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,  -166,  -166,  -166,  -166,  -166,
       0,   218,   219,   220,   221,   222,   223,     0,     0,   224,
     225,   226,   227,   228,   229,     0,    33,    34,    35,    36,
      37,    38,    39,    40,    41,     0,     0,     0,    42,     0,
       0,     0,     0,     0,    43,     0,     0,     0,    44,    45,
      46,    47,     0,     0,     0,    48,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,    50,    51,
      52,    53,     0,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,     1,     0,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,  -166,
    -166,  -166,  -166,  -166,  -166,     0,     0,   224,   225,   226,
     227,   228,   229,     0,     0,     0,     0,     2,     3,     4,
       0,     0,     5,     6,     7,     0,     0,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
       0,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    33,    34,    35,    36,    37,
      38,    39,   126,    41,     0,     0,  -165,    42,     0,     0,
       0,     0,     0,    43,     0,     0,     0,    44,    45,    46,
      47,     0,     0,     0,    48,     0,     0,     0,     0,     0,
      49,     0,     0,     0,     0,     0,     0,    50,    51,    52,
      53,     0,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,     1,     0,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     3,     4,     0,
       0,     5,     6,     7,     0,     0,     8,     9,    10,    11,
      12,    13,    14,    15,     0,    16,    17,    18,    19,     0,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,    34,    35,    36,    37,    38,
      39,   126,    41,     0,  -165,     0,    42,     0,     0,     0,
       0,     0,    43,     0,     0,     0,    44,    45,    46,    47,
       0,     0,     0,    48,     0,     0,     0,     0,     0,    49,
       0,     0,     0,     0,     0,     0,    50,    51,    52,    53,
       0,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,     1,     0,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     3,     4,     0,     0,
       5,     6,     7,     0,     0,     8,     9,    10,    11,    12,
      13,    14,    15,     0,    16,    17,    18,    19,     0,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,    34,    35,    36,    37,    38,    39,
      40,    41,     0,     0,   290,    42,     0,     0,     0,     0,
       0,    43,     0,     0,     0,    44,    45,    46,    47,     0,
       0,     0,    48,     0,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,    50,    51,    52,    53,     0,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,     1,     0,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     3,     4,     0,     0,     5,
       6,     7,     0,     0,     8,     9,    10,    11,    12,    13,
      14,    15,     0,    16,    17,    18,    19,     0,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,    34,    35,    36,    37,    38,    39,    40,
      41,     0,     0,     0,    42,     0,     0,     0,     0,     0,
      43,     0,     0,     0,    44,    45,    46,    47,     0,     0,
       0,    48,     0,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,     0,    50,    51,    52,    53,     0,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,     1,     0,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     3,     4,     0,     0,     5,     6,
       7,     0,     0,     8,     9,    10,    11,    12,    13,    14,
      15,     0,   105,    17,    18,    19,     0,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    33,    34,    35,    36,    37,    38,    39,   106,    41,
       0,     0,     0,    42,     0,     0,     0,     0,     0,    43,
       0,     0,     0,    44,    45,    46,    47,     0,     0,     0,
      48,     0,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,     0,    50,    51,    52,    53,     0,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
       1,     0,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     0,     0,     5,     6,     7,
       0,     0,     8,     9,    10,    11,    12,    13,    14,    15,
       0,   234,    17,    18,    19,     0,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,    34,    35,    36,    37,    38,    39,    40,    41,     0,
       0,     0,    42,     0,     0,     0,     0,     0,    43,     0,
       0,     0,    44,    45,    46,    47,     0,     0,     0,    48,
       0,     0,     0,     0,     0,    49,     0,     0,     0,     0,
       0,     0,    50,    51,    52,    53,   207,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,     0,
       0,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,     0,   208,   209,   210,   211,   212,     0,
       0,     0,     0,     0,   207,     0,     0,     0,     0,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,   223,     0,     0,   224,   225,   226,   227,   228,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   208,   209,   210,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
     214,   215,   216,   217,   307,   218,   219,   220,   221,   222,
     223,     0,     0,   224,   225,   226,   227,   228,   229,   208,
     209,   210,   211,   212,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,   223,     0,     0,
     224,   225,   226,   227,   228,   229,     0,     0,     0,     0,
       0,     0,   308,     0,     0,     0,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,   214,   215,   216,   217,   309,
     218,   219,   220,   221,   222,   223,     0,     0,   224,   225,
     226,   227,   228,   229,   208,   209,   210,   211,   212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   213,   214,   215,   216,   217,   235,   218,   219,   220,
     221,   222,   223,     0,     0,   224,   225,   226,   227,   228,
     229,     0,     0,     0,     0,   207,     0,   310,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     320,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,   223,   314,   207,   224,   225,   226,   227,
     228,   229,     0,   208,   209,   210,   211,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,   223,     0,     0,   224,   225,   226,   227,   228,   229,
       0,   321,     0,   208,   209,   210,   211,   212,   206,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,   223,     0,     0,   224,   225,   226,   227,   228,   229,
       0,     0,     0,     0,     0,   266,     0,     0,     0,     0,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,   223,
     207,     0,   224,   225,   226,   227,   228,   229,   208,   209,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,   207,     0,   224,
     225,   226,   227,   228,   229,     0,     0,     0,   208,   209,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   231,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,     0,   207,   224,
     225,   226,   227,   228,   229,   208,   209,   210,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   237,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,   223,     0,     0,   224,   225,   226,   227,
     228,   229,   252,   207,     0,     0,   208,   209,   210,   211,
     212,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,   223,     0,     0,   224,   225,   226,
     227,   228,   229,   207,     0,     0,     0,     0,   253,     0,
       0,   208,   209,   210,   211,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,   223,
     207,     0,   224,   225,   226,   227,   228,   229,     0,     0,
     258,   208,   209,   210,   211,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,   223,
     207,     0,   224,   225,   226,   227,   228,   229,   208,   209,
     210,   211,   212,     0,   259,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,   207,     0,   224,
     225,   226,   227,   228,   229,     0,     0,     0,   208,   209,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   265,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,   207,     0,   224,
     225,   226,   227,   228,   229,   208,   209,   210,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     322,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,   223,   207,     0,   224,   225,   226,   227,
     228,   229,     0,     0,     0,   208,   209,   210,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     325,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,   223,   207,     0,   224,   225,   226,   227,
     228,   229,   208,   209,   210,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   326,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
     223,     0,     0,   224,   225,   226,   227,   228,   229,   337,
     207,     0,   208,   209,   210,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
     223,     0,     0,   224,   225,   226,   227,   228,   229,     0,
     207,     0,     0,     0,     0,   341,     0,     0,   208,   209,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,     0,     0,   224,
     225,   226,   227,   228,   229,   342,   207,     0,   208,   209,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,     0,     0,   224,
     225,   226,   227,   228,   229,     0,   207,     0,     0,     0,
       0,   343,     0,     0,   208,   209,   210,   211,   212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,   223,     0,     0,   224,   225,   226,   227,   228,
     229,   344,   207,     0,   208,   209,   210,   211,   212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,   223,     0,     0,   224,   225,   226,   227,   228,
     229,   207,     0,     0,     0,     0,     0,   346,     0,     0,
     208,   209,   210,   211,   212,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,   223,   207,
       0,   224,   225,   226,   227,   228,   229,   348,     0,   208,
     209,   210,   211,   212,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,   223,     0,     0,
     224,   225,   226,   227,   228,   229,     0,   208,   209,   210,
     211,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,   223,     0,     0,   224,   225,
     226,   227,   228,   229,   209,   210,   211,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,   223,     0,     0,   224,   225,   226,   227,   228,   229,
     210,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,   223,   211,   212,   224,
     225,   226,   227,   228,   229,     0,     0,     0,     0,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,   223,   212,     0,   224,   225,   226,   227,   228,
     229,     0,     0,     0,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,   223,   332,     0,
     224,   225,   226,   227,   228,   229,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,   223,     0,
       0,   224,   225,   226,   227,   228,   229,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-129))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-166))

static const yytype_int16 yycheck[] =
{
       0,   117,     2,     3,     4,     5,    98,    98,    99,   137,
     138,   139,   140,    98,   121,   122,   123,   124,   125,    98,
     127,   128,   129,   130,   131,   132,    98,    99,   135,   136,
     137,   138,   139,   140,    36,   117,    98,   119,    38,    39,
      40,   132,    42,    43,    98,   130,   132,    98,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    98,    99,   184,    52,
      52,   118,   117,    98,   119,    98,   106,    56,    52,   126,
     135,   136,   137,   138,   139,   140,   133,     6,     7,   119,
     120,   121,   122,    99,    99,   119,   126,    52,   132,   119,
     132,    52,   132,   102,   130,   119,   184,   101,   101,   101,
     132,   101,   140,    99,   101,    98,    98,   263,   119,   130,
     238,   256,   101,    -1,    -1,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,    -1,   184,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,    -1,    -1,    -1,   104,
     105,   106,   107,   108,    -1,    -1,    -1,    -1,    -1,   259,
      -1,    -1,   262,    -1,   264,   265,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,   140,    -1,    -1,    -1,   127,
     128,   129,   130,   131,   132,   295,   296,   135,   136,   137,
     138,   139,   140,    -1,    -1,     0,     1,   307,   308,   309,
     310,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,
     320,    -1,   322,    -1,    -1,   325,   326,   327,    -1,   184,
      -1,    -1,   332,    -1,    -1,    -1,    -1,    -1,    33,    34,
      35,    -1,    -1,    38,    39,    40,    -1,   347,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,   140,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,
     115,   116,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,     1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   127,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,   140,    -1,    -1,    -1,    -1,    33,    34,    35,
      -1,    -1,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,    -1,    -1,
      -1,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,   115,
     116,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,     1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,
      -1,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,    -1,   101,    -1,   103,    -1,    -1,    -1,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,   115,   116,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,     1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,    -1,    -1,   102,   103,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,    -1,   113,   114,   115,   116,    -1,
      -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,   133,   134,   135,   136,    -1,
      -1,    -1,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,     1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,
     109,    -1,    -1,    -1,   113,   114,   115,   116,    -1,    -1,
      -1,   120,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,     1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    35,    -1,    -1,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
      -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,   115,   116,    -1,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
       1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    35,    -1,    -1,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,    -1,
      -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,    -1,
      -1,    -1,   113,   114,   115,   116,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,   133,   134,   135,   136,    56,    -1,    -1,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   104,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
     140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,   105,   106,   107,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,
     122,   123,   124,   125,   184,   127,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,   140,   104,
     105,   106,   107,   108,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,   140,    -1,    -1,    -1,    -1,
      -1,    -1,   184,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,   184,
     127,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,   140,   104,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,    37,   127,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
     140,    -1,    -1,    -1,    -1,    56,    -1,   184,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,   184,    56,   135,   136,   137,   138,
     139,   140,    -1,   104,   105,   106,   107,   108,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,   140,
      -1,   102,    -1,   104,   105,   106,   107,   108,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,   140,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
      56,    -1,   135,   136,   137,   138,   139,   140,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    56,    -1,   135,
     136,   137,   138,   139,   140,    -1,    -1,    -1,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    -1,    56,   135,
     136,   137,   138,   139,   140,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,
      -1,    -1,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,   140,   100,    56,    -1,    -1,   104,   105,   106,   107,
     108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   121,   122,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,   140,    56,    -1,    -1,    -1,    -1,   101,    -1,
      -1,   104,   105,   106,   107,   108,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
      56,    -1,   135,   136,   137,   138,   139,   140,    -1,    -1,
     103,   104,   105,   106,   107,   108,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
      56,    -1,   135,   136,   137,   138,   139,   140,   104,   105,
     106,   107,   108,    -1,   110,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    56,    -1,   135,
     136,   137,   138,   139,   140,    -1,    -1,    -1,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    56,    -1,   135,
     136,   137,   138,   139,   140,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    56,    -1,   135,   136,   137,   138,
     139,   140,    -1,    -1,    -1,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,   121,   122,   123,   124,   125,    -1,   127,   128,
     129,   130,   131,   132,    56,    -1,   135,   136,   137,   138,
     139,   140,   104,   105,   106,   107,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,   121,
     122,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,   140,   101,
      56,    -1,   104,   105,   106,   107,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,
     122,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,   140,    -1,
      56,    -1,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,   140,   101,    56,    -1,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,   140,    -1,    56,    -1,    -1,    -1,
      -1,   101,    -1,    -1,   104,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
     140,   101,    56,    -1,   104,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
     140,    56,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
     104,   105,   106,   107,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,    56,
      -1,   135,   136,   137,   138,   139,   140,   102,    -1,   104,
     105,   106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,   140,    -1,   104,   105,   106,
     107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,    -1,
     127,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,   140,   105,   106,   107,   108,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     121,   122,   123,   124,   125,    -1,   127,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,   140,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,
      -1,   127,   128,   129,   130,   131,   132,   107,   108,   135,
     136,   137,   138,   139,   140,    -1,    -1,    -1,    -1,    -1,
      -1,   121,   122,   123,   124,   125,    -1,   127,   128,   129,
     130,   131,   132,   108,    -1,   135,   136,   137,   138,   139,
     140,    -1,    -1,    -1,    -1,    -1,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   112,    -1,
     135,   136,   137,   138,   139,   140,    -1,   121,   122,   123,
     124,   125,    -1,   127,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,   140,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    33,    34,    35,    38,    39,    40,    43,    44,
      45,    46,    47,    48,    49,    50,    52,    53,    54,    55,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   103,   109,   113,   114,   115,   116,   120,   126,
     133,   134,   135,   136,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   194,   195,   196,   197,   198,
     199,   200,   201,   196,   196,    52,    98,   196,   207,   196,
      52,    98,   203,   204,   207,    52,   207,    98,    98,    98,
      98,    98,    98,   196,   196,   196,    98,   196,   205,   206,
     196,   196,    98,    98,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,   202,    52,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,     0,   196,    51,    56,   104,   105,
     106,   107,   108,   121,   122,   123,   124,   125,   127,   128,
     129,   130,   131,   132,   135,   136,   137,   138,   139,   140,
      99,   119,    36,   132,    52,    37,   119,   118,   184,    52,
     117,   119,   117,   119,   119,    52,   203,   205,   196,   196,
     196,   196,   100,   101,   196,   205,   184,   102,   103,   110,
     196,   205,   130,    98,   130,   119,    51,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     102,   196,   196,   196,   196,   132,   119,   196,   196,   204,
     196,   196,   196,   196,   196,   101,   101,   184,   184,   184,
     184,   101,   206,   196,   184,   101,   196,   203,   196,   196,
      41,   102,   119,   196,   196,   119,   119,   119,   196,   196,
     196,   196,   112,   196,   101,   196,   196,   101,   196,   196,
     196,   101,   101,   101,   101,   196,   101,   130,   102,   196
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 117 "parser.y"
    { (yyval.nodetype)=(yyvsp[(1) - (1)].nodetype); Parseroot=(yyval.nodetype);  if (INTERACTIVE) return(0);}
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 120 "parser.y"
    { (yyval.nodetype) = node2(AND,(yyvsp[(1) - (3)].nodetype),(yyvsp[(2) - (3)].nodetype));  }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 121 "parser.y"
    { (yyval.nodetype)=(yyvsp[(1) - (2)].nodetype);   }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 127 "parser.y"
    { (yyval.nodetype) = (yyvsp[(2) - (3)].nodetype); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 128 "parser.y"
    { (yyval.nodetype) = (yyvsp[(2) - (3)].nodetype); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 131 "parser.y"
    { (yyval.nodetype) = node3(IF,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype),True); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 132 "parser.y"
    { (yyval.nodetype) = node3(IF,(yyvsp[(2) - (6)].nodetype),(yyvsp[(4) - (6)].nodetype),(yyvsp[(6) - (6)].nodetype)); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 133 "parser.y"
    { (yyval.nodetype) = node2(IMPLIES,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 136 "parser.y"
    { (yyval.nodetype) = node2(WHILE,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 137 "parser.y"
    { (yyval.nodetype) = node3(FORIN,(yyvsp[(2) - (6)].nodetype),(yyvsp[(4) - (6)].nodetype),(yyvsp[(6) - (6)].nodetype)); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 138 "parser.y"
    { (yyval.nodetype) = node2(FORTIMES,(yyvsp[(2) - (5)].nodetype),(yyvsp[(5) - (5)].nodetype)); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 139 "parser.y"
    { (yyval.nodetype) = node3(FOR,node_lnk_1((yyvsp[(2) - (4)].nodetype)),node_lnk_2((yyvsp[(2) - (4)].nodetype)),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 140 "parser.y"
    { (yyval.nodetype) = node1(CHOPSTAR,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 141 "parser.y"
    { (yyval.nodetype) = node2(REPEAT,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 144 "parser.y"
    { (yyval.nodetype) = node4(EXISTS,(yyvsp[(2) - (4)].nodetype),NULL,(yyvsp[(4) - (4)].nodetype),One); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 145 "parser.y"
    {
    if (node_ival((yyvsp[(4) - (6)].nodetype))<1 || node_type((yyvsp[(4) - (6)].nodetype))!= INT)
            syntax_error(H1);
      (yyval.nodetype) = node4(EXISTS,(yyvsp[(2) - (6)].nodetype),NULL,(yyvsp[(6) - (6)].nodetype),(yyvsp[(4) - (6)].nodetype)); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 149 "parser.y"
    { (yyval.nodetype) = node4(EXISTS,node_lnk_1((yyvsp[(2) - (4)].nodetype)),node_lnk_2((yyvsp[(2) - (4)].nodetype)),(yyvsp[(4) - (4)].nodetype),One); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 150 "parser.y"
    { if (node_ival((yyvsp[(4) - (6)].nodetype))<1 || node_type((yyvsp[(4) - (6)].nodetype))!= INT)
            syntax_error(H1);
      (yyval.nodetype) = node4(EXISTS,node_lnk_1((yyvsp[(2) - (6)].nodetype)),node_lnk_2((yyvsp[(2) - (6)].nodetype)),(yyvsp[(6) - (6)].nodetype),(yyvsp[(4) - (6)].nodetype)); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 153 "parser.y"
    { (yyval.nodetype) = node3(FORALL,node_lnk_1((yyvsp[(2) - (4)].nodetype)),node_lnk_2((yyvsp[(2) - (4)].nodetype)),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 156 "parser.y"
    { (yyval.nodetype) = node2(RUN,(yyvsp[(2) - (2)].nodetype),True); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 157 "parser.y"
    { (yyval.nodetype) = node1(LOAD,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 158 "parser.y"
    { (yyval.nodetype) = node1(FORMAT,(yyvsp[(3) - (4)].nodetype)); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 159 "parser.y"
    { (yyval.nodetype) = node1(OUTPUT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 160 "parser.y"
    { (yyval.nodetype) = node1(WINPUT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 161 "parser.y"
    { (yyval.nodetype) = node1(INPUT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 162 "parser.y"
    { (yyval.nodetype) = node1(PEEK,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 163 "parser.y"
    { (yyval.nodetype) = node2(DEFINE,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 164 "parser.y"
    { (yyval.nodetype) = node2(DEFINE,(yyvsp[(2) - (7)].nodetype),node2(LAMBDA,(yyvsp[(4) - (7)].nodetype),(yyvsp[(7) - (7)].nodetype))); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 165 "parser.y"
    { (yyval.nodetype) = node1(TYPE,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 166 "parser.y"
    { (yyval.nodetype) = node1(ASCII,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 167 "parser.y"
    { (yyval.nodetype) = node2(SET,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 168 "parser.y"
    { (yyval.nodetype) = node1(HELP,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 169 "parser.y"
    { (yyval.nodetype) = node1(SYSTEM,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 170 "parser.y"
    { (yyval.nodetype) = node2(CALL,(yyvsp[(1) - (4)].nodetype),(yyvsp[(3) - (4)].nodetype)); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 171 "parser.y"
    { (yyval.nodetype) = node2(LAMBDA,(yyvsp[(3) - (6)].nodetype),(yyvsp[(6) - (6)].nodetype)); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 172 "parser.y"
    { (yyval.nodetype) = node2(THE,(yyvsp[(2) - (4)].nodetype),(yyvsp[(4) - (4)].nodetype)); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 173 "parser.y"
    { (yyval.nodetype)=node2(SHOWMEM,(yyvsp[(3) - (6)].nodetype),(yyvsp[(5) - (6)].nodetype));    }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 176 "parser.y"
    { (yyval.nodetype) = node2(OR,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 177 "parser.y"
    { (yyval.nodetype) = node2(AND,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype));  }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 178 "parser.y"
    { (yyval.nodetype) = node2(WHERE,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 179 "parser.y"
    { (yyval.nodetype) = node1(NOT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 182 "parser.y"
    { (yyval.nodetype) = node2(SEMI,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 183 "parser.y"
    { (yyval.nodetype) = node2(GETS,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 184 "parser.y"
    { (yyval.nodetype) = node2(IS,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 185 "parser.y"
    { (yyval.nodetype) = node2(ASSN,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 186 "parser.y"
    { (yyval.nodetype) = node2(UASSN,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 187 "parser.y"
    { (yyval.nodetype) = node2(DEFAULTS,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 188 "parser.y"
    { (yyval.nodetype) = node1(PROCESS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 189 "parser.y"
    { (yyval.nodetype) = node1(PREFIX,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 190 "parser.y"
    { (yyval.nodetype) = node2(PROJ,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 191 "parser.y"
    { (yyval.nodetype) = node1(ALWAYS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 192 "parser.y"
    { (yyval.nodetype) = node1(SOMETIME,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 193 "parser.y"
    { (yyval.nodetype) = node1(HALT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 194 "parser.y"
    { (yyval.nodetype) = node1(LEN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 195 "parser.y"
    { (yyval.nodetype) = node1(MEM,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 196 "parser.y"
    { (yyval.nodetype) = node1(FIN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 197 "parser.y"
    { (yyval.nodetype) = node1(INIT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 198 "parser.y"
    { (yyval.nodetype) = node1(KEEP,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 199 "parser.y"
    { (yyval.nodetype) = node1(STB,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 200 "parser.y"
    { (yyval.nodetype) = node1(STRUCT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 201 "parser.y"
    { (yyval.nodetype) = node1(NEXT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 202 "parser.y"
    { (yyval.nodetype) = node1(WNEXT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 203 "parser.y"
    { (yyval.nodetype) = node1(PREV,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 204 "parser.y"
    { (yyval.nodetype) = node2(NPREV,(yyvsp[(3) - (6)].nodetype), (yyvsp[(5) - (6)].nodetype)); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 207 "parser.y"
    { (yyval.nodetype) = node2(LT,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 208 "parser.y"
    { (yyval.nodetype) = node2(LE,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 209 "parser.y"
    { (yyval.nodetype) = node2(EQ,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 210 "parser.y"
    { (yyval.nodetype) = node2(GE,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 211 "parser.y"
    { (yyval.nodetype) = node2(GT,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 212 "parser.y"
    { (yyval.nodetype) = node2(NEQ,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 215 "parser.y"
    { (yyval.nodetype) = node1(REFER,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 216 "parser.y"
    { (yyval.nodetype) = node1(DEREF,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 219 "parser.y"
    { (yyval.nodetype) = node1(UPLUS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 220 "parser.y"
    { (yyval.nodetype) = node1(UMINUS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 221 "parser.y"
    { (yyval.nodetype) = node2(PLUS,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 222 "parser.y"
    { (yyval.nodetype) = node2(MINUS,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 223 "parser.y"
    { (yyval.nodetype) = node2(MULT,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 224 "parser.y"
    { (yyval.nodetype) = node2(DIV,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 225 "parser.y"
    { (yyval.nodetype) = node2(MOD,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 226 "parser.y"
    { (yyval.nodetype) = node2(POWER,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 227 "parser.y"
    { (yyval.nodetype) = node1(CEIL,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 228 "parser.y"
    { (yyval.nodetype) = node1(FLOOR,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 229 "parser.y"
    { (yyval.nodetype) = node1(SQRT,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 230 "parser.y"
    { (yyval.nodetype) = node1(ITOF,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 231 "parser.y"
    { (yyval.nodetype) = node1(EXPO,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 232 "parser.y"
    { (yyval.nodetype) = node1(LOG,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 233 "parser.y"
    { (yyval.nodetype) = node1(LOGTEN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 234 "parser.y"
    { (yyval.nodetype) = node1(SIN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 235 "parser.y"
    { (yyval.nodetype) = node1(COS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 236 "parser.y"
    { (yyval.nodetype) = node1(TAN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 237 "parser.y"
    { (yyval.nodetype) = node1(ASIN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 238 "parser.y"
    { (yyval.nodetype) = node1(ACOS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 239 "parser.y"
    { (yyval.nodetype) = node1(ATAN,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 240 "parser.y"
    { (yyval.nodetype) = node1(SINH,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 241 "parser.y"
    { (yyval.nodetype) = node1(COSH,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 242 "parser.y"
    { (yyval.nodetype) = node1(TANH,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 243 "parser.y"
    { (yyval.nodetype) = node1(FABS,(yyvsp[(2) - (2)].nodetype)); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 244 "parser.y"
    { (yyval.nodetype) = node2(ATANTWO,(yyvsp[(3) - (6)].nodetype),(yyvsp[(5) - (6)].nodetype)); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 249 "parser.y"
    { (yyval.nodetype) = node2(FIXLIST,(yyvsp[(3) - (6)].nodetype),(yyvsp[(5) - (6)].nodetype)); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 250 "parser.y"
    { (yyval.nodetype) = node2(VARLIST,(yyvsp[(3) - (6)].nodetype),(yyvsp[(5) - (6)].nodetype)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 251 "parser.y"
    { (yyval.nodetype) = node1(SIZE,(yyvsp[(2) - (3)].nodetype)); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 265 "parser.y"
    { (yyval.nodetype) = node1(MAKELIST,(yyvsp[(2) - (3)].nodetype)); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 269 "parser.y"
    { (yyval.nodetype) = node2(SUB,(yyvsp[(1) - (3)].nodetype),NULL); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 270 "parser.y"
    { (yyval.nodetype) = node2(SUB,(yyvsp[(1) - (4)].nodetype),(yyvsp[(3) - (4)].nodetype)); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 271 "parser.y"
    { (yyval.nodetype) = node3(SUBLIST,(yyvsp[(1) - (6)].nodetype),(yyvsp[(3) - (6)].nodetype),(yyvsp[(5) - (6)].nodetype)); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 276 "parser.y"
    { (yyval.nodetype) = node2(CALL,(yyvsp[(1) - (4)].nodetype),(yyvsp[(3) - (4)].nodetype)); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 285 "parser.y"
    { (yyval.nodetype)=True;    }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 286 "parser.y"
    { (yyval.nodetype)=False;    }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 287 "parser.y"
    { (yyval.nodetype)=Nil;    }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 289 "parser.y"
    { (yyval.nodetype)=Empty;    }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 290 "parser.y"
    { (yyval.nodetype)=Skip;    }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 291 "parser.y"
    { (yyval.nodetype)=More;    }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 292 "parser.y"
    { (yyval.nodetype)=Ranlen;    }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 293 "parser.y"
    { (yyval.nodetype)=Infinite;    }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 294 "parser.y"
    { (yyval.nodetype)=Random;    }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 295 "parser.y"
    { (yyval.nodetype)=RRandom;    }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 296 "parser.y"
    { (yyval.nodetype)=SRandom;    }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 297 "parser.y"
    { (yyval.nodetype)=SRRandom;    }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 336 "parser.y"
    { (yyval.nodetype) = NULL; }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 342 "parser.y"
    { (yyval.nodetype) = node2(COMMA,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 346 "parser.y"
    { (yyval.nodetype) = NULL; }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 348 "parser.y"
    { (yyval.nodetype) = (yyvsp[(2) - (3)].nodetype); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 352 "parser.y"
    { (yyval.nodetype) = node2(COMMA,(yyvsp[(1) - (1)].nodetype),NULL); }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 353 "parser.y"
    { (yyval.nodetype) = node2(COMMA,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 357 "parser.y"
    { (yyval.nodetype) = node2(LT,(yyvsp[(1) - (3)].nodetype),(yyvsp[(3) - (3)].nodetype)); }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 358 "parser.y"
    { (yyval.nodetype) = node2(LT,(yyvsp[(2) - (5)].nodetype),(yyvsp[(4) - (5)].nodetype)); }
    break;



/* Line 1806 of yacc.c  */
#line 3556 "parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 363 "parser.y"


NODEPTR parse(stream)
FILE *stream;
{
    NODEPTR p;

    if (InputFile != stream) {
        EOFILE=0;
        if (yydebug)
            printf("restarting parse\n");
        yyrestart(stream);
        InputFile = stream;
    }
        
    yydebug = (DebugLevel>=6) ? 1 : 0;
    
    yyerrorcount = 0;
        
    if ((yyparse () == 0) && (yyerrorcount == 0)) {
        if (yydebug) {
             printf("in parse-old type before\n");
             output_expn(Parseroot,-1);
             printf("\n after \n");
        }
        p= resolve_refs (Parseroot);
        if (yydebug) {
            output_expn(p,-1);
            printf("\n");
            printf("EOFILE=%d\n",EOFILE);
        }
        return(p);
    }
    else {
        if (yydebug)
            printf("yyerrorcount %d\n", yyerrorcount);
        return(True);
    }
        
}

NODEPTR resolve_refs (e)
NODEPTR e;
{
    if (e == NULL || e == LastCommand)
        return (e);
    switch (node_type(e)) {
        case NAME:
	    return (lookup_env (node_sym_name(e)));
        case NIL:
        case BOOL:
        case INT:
        case STRING:
        case FLOAT:
        case LOC:
            return (e);
        case EXISTS:
            push_scope1 (node_lnk_1(e),node_ival(node_lnk_4(e)));
	    node_lnk_3(e) = resolve_refs (node_lnk_3(e));
	    node_lnk_2(e) = resolve_refs (node_lnk_2(e));
	    node_lnk_1(e) = pop_scope ();
	    return (e);
        case FORALL:
        case FORIN:
        case FOR:
	    push_scope1 (node_lnk_1(e),1);
	    node_lnk_3(e) = resolve_refs (node_lnk_3(e));
	    node_lnk_2(e) = resolve_refs (node_lnk_2(e));
	    node_lnk_1(e) = pop_scope ();
	    return (e);
        case LAMBDA:
	    push_scope1 (node_lnk_1(e),1);
	    node_lnk_2(e) = resolve_refs (node_lnk_2(e));
	    node_lnk_1(e) = pop_scope ();
	    return (e);
        case FORTIMES:
        case IF:
        case SUBLIST:
            node_lnk_3(e) = resolve_refs (node_lnk_3(e));
        case PROJ:
        case COMMA:
        case DEFINE:
        case WHILE:
        case REPEAT:
        case LT:
        case LE:
        case EQ:
        case GE:
        case GT:
        case NEQ:
        case PLUS:
        case MINUS:
        case MULT:
        case DIV:
        case POWER:
        case SEMI:
        case WHERE:
        case AND:
        case OR:
        case IMPLIES:    
        case GETS:
        case IS:
        case MOD:
        case ATANTWO:
        case ASSN:
        case UASSN:
        case CALL:
        case SUB:
        case FIXLIST:
        case VARLIST:
        case NPREV:
        case RUN:
        case SET:
        case SHOWMEM:
        case DEFAULTS:
            node_lnk_2(e) = resolve_refs (node_lnk_2(e));
        case NOT:
        case UPLUS:
        case UMINUS:
        case CEIL:
        case FLOOR:
        case SQRT:
        case ITOF:
        case EXPO:
        case LOG:
        case LOGTEN:
        case SIN:
        case COS:
        case TAN:
        case ASIN:
        case ACOS:
        case ATAN:
        case SINH:
        case COSH:
        case TANH:
        case FABS:
        case PROCESS:
        case PREFIX:
        case ALWAYS:
        case SOMETIME:
        case HALT:
        case INIT:
        case FIN:
        case CHOPSTAR:    
        case KEEP:    
        case NEXT:
        case WNEXT:
        case PREV:
        case LEN:
        case STB:
        case MEM:
        case STRUCT:
        case INPUT:
        case WINPUT:
        case OUTPUT:
        case PEEK:
        case HELP:
        case SYSTEM:
        case TYPE:
        case iUNDEFINED:
        case ASCII:
        case FORMAT:
        case SIZE:
        case MAKELIST:
        case REFER:
        case DEREF:    
        case LOAD:
            node_lnk_1(e) = resolve_refs (node_lnk_1(e));
        default:
            return (e);
    }
}


void push_scope(name_list)
NODEPTR name_list;
{
    unsigned int level = node_env_level(EnvStack[EnvTop].env) + 1;
    if (EnvTop >= MAXENVSTACKSIZE)
         error_break0("environment stack full");
    else {
        EnvTop += 1;
        EnvStack[EnvTop].env = env_node(level, 0, NULL);
        EnvStack[EnvTop].env_base = NULL;
        install_name_list (name_list);
    }
}

void push_scope1(name_list,history)
NODEPTR name_list;
unsigned int history;
{
    unsigned int level = node_env_level(EnvStack[EnvTop].env) + 1;
    if (EnvTop >= MAXENVSTACKSIZE)
         error_break0("environment stack full");
    else {
        EnvTop += 1;
        if (history == 0)
            history=1;
        EnvStack[EnvTop].env = env_node1(level, 0, NULL, history);
        EnvStack[EnvTop].env_base = NULL;
        install_name_list (name_list);
    }
}

NODEPTR pop_scope()
{
    return (EnvStack[EnvTop--].env);
}

void install_name_list(name_list)
NODEPTR name_list;
{
    NODEPTR id;
    if (name_list == NULL)
        return;
    while (node_type(name_list) == COMMA) {
	id = node_lnk_1(name_list);
	install_local_id (node_sym_name(id));
	name_list = node_lnk_2(name_list);
    }
    install_local_id (node_sym_name(name_list));
}

NODEPTR lookup_env(s)
char *s;
{
    register NODEPTR np;
    register int level;

        /*printf("looking up %s\n",s);*/
    for (level = EnvTop; level >= EnvBase; level--)
        for (np = node_env_idlist(EnvStack[level].env);
	     np != NULL; np = node_next(np))
            if (strcmp (s, node_nm_name(np)) == 0)
                return (np);
    return (install_global_id (s));
}

NODEPTR install_global_id(name)
char *name;
{
    NODEPTR *np; 
    register    NODEPTR id;
    np = &(node_env_idlist(EnvStack[EnvBase].env));
    node_env_history(EnvStack[EnvBase].env)=1;
        /*printf("installing global: %s \n",name);*/
    if (DebugLevel>2)
        printf("Global: history=%d\n",node_env_history(EnvStack[EnvBase].env));
    id = name_node ((unsigned)isupper ((char)*name), name, 0, offset2 (GlobalMemUsed++,node_env_history(EnvStack[EnvBase].env)));
    if (GlobalMemUsed >= GLOBALMEMSIZE)
        error_break0("global memory full");
    else
	new_loc1 (mem_loc (id), node_type(id), 1);
    while (*np != NULL) {
        np = &(node_next(*np) );
    }
    return (*np = id);
}

void install_local_id(name)
char *name;
{
    NODEPTR *np; 
    register    NODEPTR id;
    np = &(node_env_idlist(EnvStack[EnvTop].env));
    if (DebugLevel>2)
        printf("Local: history=%d\n",node_env_history(EnvStack[EnvTop].env));
    id = name_node ((unsigned)isupper ((char)*name), name, node_env_level(EnvStack[EnvTop].env),
    		    offset2 (node_env_size(EnvStack[EnvTop].env)++, node_env_history(EnvStack[EnvTop].env)));
    while (*np != NULL) {
        np = &(node_next(*np) );
    }
    *np = id;
}

void syntax_error(n)
int n;
{
    yyerrorcount += 1;
    printf ("***Syntax Error");
    if (InputFile != stdin)
        printf (" on line %d of \"%s\"", yylineno-1, InputFilename);
    printf (": \n");
    fflush(stdout);
    syntax_msg (n);
    printf (".\n");
    fflush(stdout);
}

void syntax_msg(n)
int n;
{
    switch (n) {
            /*case N1:
            printf ("one identifier expected after quantifier");
            break;*/
        case MQS:
            printf ("missing quote in string");
            break;
        case MDF:
            printf ("missing $ in float");
            break;
        case EIF:
            printf ("error in float");
            break;    
        case STL:
            printf ("string too long");
            break;
        case IPTL:
            printf ("input line too long");
            break;
/*        case FTL:
            printf ("float too long");
            break;*/
        case H1:
            printf ("history should be an integer greater than zero");
            break;     
        case IDN:
            printf ("syntax error, comment does not end properly");
            break;
/*        case NLC:
            printf ("syntax error, comma without a following identifier");
            break;*/
/*        case END:
            printf ("\"%s\" unexpected (command must be terminated by \".\")",
                                                                   InputText);
                                                                   break;*/
        default:
            break;
/*            printf ("\"%s\" unexpected", InputText);
            if (MINTOKEN <= n && n <= MAXTOKEN)
            printf (" (\"%s\" expected)", Keyword[n-MINTOKEN]);*/
    }
}

void yyerror(char const *s)
{
    int i;
    
    if (EOFILE==0) {
        yyerrorcount += 1;
        printf("%s\n",Linetext);
        for (i=1; i<yylloc.first_column; i++)
            printf(" ");
        for (i=yylloc.first_column; i<=yylloc.last_column; i++)
            printf("^");
        newline;
        printf("***Syntax Error on line %d of \"%s\": `%s' unexpected\n\n",yylineno,InputFilename,yytext);
                
        
        
    }
    
    
    
}


