/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2013  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* test of io redirections
 *
 */


/* run */ define test() = { 
exists x: {
   input x and output x  and empty
}
}.

/* run */ define test0() = { 
exists x: {set infile="stdin" and set outfile="stdout" and
   input x and output x  and empty
}
}.



/* run */ define test1() = { 
exists X: { set infile="xin" and set outfile="stdout" and
   {input X  and empty and output X};skip;
   {input X  and empty and output X}
}
}.

/* run */ define test2() = { 
exists X: { set infile="xin" and set outfile="out" and
   {input X  and empty and output X};skip;
   {input X  and empty and output X};skip;
   {set infile="stdin" and input X  and empty and output X}
}
}.

/* run */ define test3() = { 
exists x: {set outfile="xout.append" and set infile="xin" and
   input x and format("this is test of x=%d appended to a file\n",x)  and empty
}
}.

/* run */ define test4() = { 
exists X: { set infile="xin.does.not.exist" and set outfile="stdout" and
   {input X  and empty and output X};skip;
   {input X  and empty and output X};skip;
   {set infile="stdin" and input X  and empty and output X}
}
}.

/* run */ define test5() = { 
exists x: {set outfile="out.readonly" and set infile="stdin" and
   input x and format("x=%d\n",x)  and empty
}
}.

/* run */ define test6() = { 
exists X: { set infile="xin.exist.not.readable" and set
outfile="stdout" and 
   {input X  and empty and output X};skip;
   {input X  and empty and output X};skip;
   {set infile="stdin" and input X  and empty and output X}
}
}.

/* run */ define test7() = { 
exists X: { set infile="xin.not.enough.input" and set
outfile="stdout" and
   {input X  and empty and output X};skip;
   {input X  and empty and output X}
}
}.
